image: registry.gitlab.com/gdunstone/docker-buildx-qemu

services:
  - name: docker:dind
    entrypoint: ["env", "-u", "DOCKER_HOST"]
    command: ["dockerd-entrypoint.sh"]

stages:
  - build
  - test
  - release

variables:
  CI_BUILD_ARCHS: linux/arm64/v8,linux/amd64
  DOCKER_DRIVER: overlay2
  DOCKER_HOST: tcp://docker:2375/
  DOCKER_TLS_CERTDIR: ""
  IMAGE_ADDR: $CI_REGISTRY_IMAGE:$CI_COMMIT_SHA
  IMAGE_CACHE: $CI_REGISTRY_IMAGE/cache:$CI_COMMIT_SHA
  IMAGE_FINAL: $CI_REGISTRY_IMAGE:$CI_COMMIT_REF_NAME
  REAL_JAVA_ADDR: $CI_REGISTRY/synacksynack/opsperator/docker-java:15-20211226

build:
  stage: build
  before_script:
    - docker login -u $CI_REGISTRY_USER -p $CI_REGISTRY_PASSWORD $CI_REGISTRY
    - update-binfmts --enable
    - docker buildx create --driver docker-container --use
    - docker buildx inspect --bootstrap
  script:
    - sed -i "s|FROM opsperator/java|FROM $REAL_JAVA_ADDR|" Dockerfile.csd4
    - >
        docker buildx build --platform $CI_BUILD_ARCHS \
            --cache-from=type=registry,ref=$IMAGE_CACHE \
            --cache-to=type=registry,ref=$IMAGE_CACHE \
            --build-arg=DO_UPGRADE=yes \
            --progress plain --pull --push \
            -t "$IMAGE_ADDR" -f Dockerfile .

test:
  stage: test
  before_script:
    - docker login -u $CI_REGISTRY_USER -p $CI_REGISTRY_PASSWORD $CI_REGISTRY
  image: docker:19.03.12
  retry:
    max: 2
  script:
    - >
        docker run --name testcsd \
            -e CASSANDRA_CLUSTER_NAME=mycluster \
            -e CASSANDRA_DC=DC1 \
            -e CASSANDRA_HOSTNAME=csd0 \
            -e CASSANDRA_RACK=RACK1 \
            -e DEBUG=yay \
            -e HEAP_NEWSIZE=64M \
            -e MAX_HEAP_SIZE=256M \
            -d $IMAGE_ADDR
    - sleep 120
    - >
        works=false;
        for try in 1 2 3 4 5;
        do
            echo "=== Test $try/5 ==="
            if docker exec testcsd /bin/sh -c '/is-ready.sh && echo OK' | grep OK; then
                works=true;
                break;
            elif test $try -eq 5; then
                break;
            fi;
            echo retrying in 60 seconds;
            sleep 60;
        done;
        echo "=== Container Logs ===";
        docker logs testcsd;
        echo "=== Cleaning Up ===";
        docker rm -f testcsd;
        if $works; then
            echo "Test: OK, Cassandra starts and listens";
        else
            echo "Test: KO, Cassandra does not answer";
            exit 1;
        fi

scan:
  stage: test
  image:
    name: docker.io/aquasec/trivy
    entrypoint: [""]
  script:
    - trivy image "$IMAGE_ADDR" || echo too-bad

retag:
  stage: release
  image:
    name: quay.io/skopeo/stable
    entrypoint: [""]
  script:
    - >
        if test "$CI_COMMIT_TAG"; then
            skopeo copy --all \
                --src-creds=$CI_REGISTRY_USER:$CI_REGISTRY_PASSWORD \
                --dest-creds=$CI_REGISTRY_USER:$CI_REGISTRY_PASSWORD \
                docker://$IMAGE_ADDR docker://$CI_REGISTRY_IMAGE:$CI_COMMIT_TAG
        else
            skopeo copy \
                --dest-creds=$CI_REGISTRY_USER:$CI_REGISTRY_PASSWORD \
                --src-creds=$CI_REGISTRY_USER:$CI_REGISTRY_PASSWORD \
                docker://$IMAGE_ADDR docker://$IMAGE_FINAL
        fi

release-code:
  rules:
    - if: $CI_COMMIT_TAG
  stage: release
  image: registry.gitlab.com/gitlab-org/release-cli:latest
  release:
    name: 'Release $CI_COMMIT_TAG'
    description: '$CI_REGISTRY_IMAGE:$CI_COMMIT_TAG'
    ref: '$CI_COMMIT_TAG'
    tag_name: '$CI_COMMIT_TAG'
  script:
    - echo 'Releasing $CI_REGISTRY_IMAGE:$CI_COMMIT_TAG'
